<template>
  <div
    ref="activatorLink"
    class="w-full"
    :class="[withPadding ? 'px-15 py-6' : '', withBorder ? 'rounded-lg border border-borderColor border-opacity-100' : '']"
  >
    <bubble-menu
      v-show="showMenu && (extensionSelection?.length || extensionGlobal?.includes(Link))"
      :editor="editor"
      plugin-key="textMenu"
      :update-delay="0"
    >
      <div
        class="flex items-center rounded-[8px] p-2 bg-surface cardShadow"
        :class="size === 'default' ? 'w-fit' : 'w-[272px] overflow-x-auto'"
      >
        <div v-if="extensionSelection?.length" class="flex items-center justify-center gap-2">
          <ContentTypePicker
            :size="size"
            :editor="editor"
            :selection-items="extensionSelectionList"
            :active-item="useTextMenuContentTypes(editor).find(element => element.type === 'option' && element.isActive())"
          />
          
          <FontFamilyPicker
            v-if="extensionSelection?.includes(FontFamily)"
            :size="size"
            :value="useTextStates(editor).currentFont"
            @select-font="useTextMenuCommands(editor).onSetFont($event)"
          />

          <FontSizePicker
            v-if="extensionSelection?.includes(FontSize)"
            :size="size"
            :value="useTextStates(editor).currentSize"
            @change-size="useTextMenuCommands(editor).onSetFontSize($event)"
          />
        </div>

        <svn-pro-divider
          v-if="extensionSelectionList?.some(el => ['bold', 'italic', 'underline', 'strike', 'link', 'highlight', 'color', 'textAlign']?.includes(el))"
          :vertical="true"
          color="borderColor"
          class="mx-2"
        />

        <TextActionsPicker
          v-if="extensionSelectionList?.some(el => ['bold', 'italic', 'underline', 'strike', 'link', 'highlight', 'color', 'textAlign']?.includes(el)) || extensionSlashCommand?.includes(Link)"
          :editor="editor"
          :size="size"
          :element-target="activatorLink"
          :extensions="extensionSlashCommand"
          :selection-items="extensionSelectionList"
        />
      </div>
    </bubble-menu>

    <TableColumnMenu
      v-if="extensionSlashCommand?.includes(Table)"
      :editor="editor"
      :element-target="activatorLink"
    />

    <TableRowMenu
      v-if="extensionSlashCommand?.includes(Table)"
      :editor="editor"
      :element-target="activatorLink"
    />
    
    <editor-content :editor="editor" />
  </div>
</template>

<script setup>
// Vue & Tiptap Imports
import { ref, onMounted, computed, onBeforeUnmount } from 'vue';
import { EditorContent, BubbleMenu, Editor } from '@tiptap/vue-3';
import { TextSelection } from '@tiptap/pm/state'

// Other imports
import SvnProDivider from '../divider/SvnProDivider.vue';

// Menus
import TableRowMenu from './menu/TableRow.vue';
import TableColumnMenu from './menu/TableColumn.vue';
import FontSizePicker from './menu/FontSizePicker.vue';
import FontFamilyPicker from './menu/FontFamilyPicker.vue';
import ContentTypePicker from './menu/ContentTypePicker.vue';
import TextActionsPicker from './menu/TextActionsPicker.vue';

// Useful Functions
import { useExtensions } from './hooks/useExtensions.js';
import { useTextStates } from './hooks/useTextStates.js';
import { useTextMenuCommands } from './hooks/useTextMenuCommands.js';
import { useTextMenuContentTypes } from './hooks/useTextMenuContentTypes.js';
import { ALLOWED_SLASH_COMMMANDS, ALLOWED_SELECTION_COMMANDS } from './utils/constants';

// Extension List
import { Emoji, FontFamily, FontSize, Link, Table } from './extensions/index';

const props = defineProps({
  htmlData: {
    type: String,
    default: '🔥Vue.js + Tiptap Block Editor Template',
  },
  withBorder: {
    type: Boolean,
    default: true,
  },
  withPadding: {
    type: Boolean,
    default: true,
  },
  isEditable: {
    type: Boolean,
    default: true,
  },
  extensionLeftMenu: {
    type: Boolean,
    default: false,
  },
  extensionSelection: {
    type: Array,
    default: () => [],
  },
  extensionSlashCommand: {
    type: Array,
    default: () => [],
  },
  extensionGlobal: {
    type: Array,
    default: () => {
      return [
        Emoji
      ]
    },
  },
  size: {
    type: String,
    default: "default",
  },
  createImageUrl: {
    type: String,
    default: "",
  },
})

onMounted(() => {
  const allowedSlashCommands = ALLOWED_SLASH_COMMMANDS
  const allowedSelectionCommands = ALLOWED_SELECTION_COMMANDS

  for (let extension of props.extensionSlashCommand) {
    if (extension?.length) {
      for (let e of extension) {
        extensionSlashList.value.push(e?.name)
      }
    } else {
      setExtensions(extension, extensionSlashList.value, allowedSlashCommands)
    }
  }

  for (let extension of props.extensionSelection) {
    setExtensions(extension, extensionSelectionList.value, allowedSelectionCommands)
  }

  if (props.createImageUrl) {
    localStorage.setItem('SvnTiptapCreateImageUrl', JSON.stringify(props.createImageUrl))
  }

  if (props?.extensionSelection?.length) {
    extensionSelectionList.value.push('paragraph')
  }

  localStorage.setItem('SvnTiptapExtensionSlashCommand', JSON.stringify(extensionSlashList.value))
})

const setExtensions = (extension, list, allowed) => {
  if (extension.name === 'heading') {
    list.push('heading1')
    list.push('heading2')
    list.push('heading3')
  } else {
    if (allowed?.includes(extension.name)) {
      list.push(extension?.name)
    }
  }
}

const emits = defineEmits(['on-save'])

const html = ref(null)
const activatorLink = ref(null);
const extensionSlashList = ref([]);
const extensionSelectionList = ref([]);

const editor = new Editor({
  content: props.htmlData,
  autofocus: props.isEditable,
  editable: props.isEditable,
  editorProps: {
    attributes: {
      autocomplete: 'off',
      autocorrect: 'off',
      autocapitalize: 'off',
      class: 'min-h-full',
    },
  },
  extensions: useExtensions(props.extensionLeftMenu, props.extensionSlashCommand, props.extensionGlobal),
});

onBeforeUnmount(() => {
  editor.destroy();

  if (localStorage.getItem('svnTiptapExtensionSlashCommand')) {
    localStorage.removeItem('SvnTiptapExtensionSlashCommand');
  }
  if (localStorage.getItem('SvnTiptapCreateImageUrl')) {
    localStorage.removeItem('SvnTiptapCreateImageUrl');
  }
});

const nodeType = computed(() => {
  const selection = editor.state.selection
  const isLink = isLinkSelection()

  const isImage = selection.node?.type.name === 'imageBlock' || selection.node?.type.name === 'imageBlockError' || selection.node?.type.name === 'imageBlockLoading'
  const isVideo = selection.node?.type.name === 'video'
  const isCodeBlock = selection.$head.parent.type.name === 'codeBlock'
  const isText = selection instanceof TextSelection

  if (isLink) return 'link'
  if (isImage) return 'image'
  if (isVideo) return 'video'
  if (isCodeBlock) return 'codeBlock'
  if (isText) return 'text'
  return selection.node?.type.name
})

const showMenu = computed(() => {
  if ((nodeType?.value === 'text' || nodeType?.value === 'link') && editor?.state?.selection?.type !== 'node') {
    return true
  }
  return false
})

const isLinkSelection = () => {
  const { schema } = editor
  const linkType = schema.marks.link
  if (!linkType) return false

  return editor.isActive(linkType.name)
}

editor.on('update', ({ editor }) => {
  html.value = editor.getHTML();
  emits('on-save', editor.getHTML());
});
</script>

<style lang="scss">
@import url('./style/style.scss');

.cardShadow {
  box-shadow: 0px 8px 10px 0px rgba(0, 0, 0, 0.14), 0px 3px 14px 0px rgba(0, 0, 0, 0.12), 0px 5px 5px 0px rgba(0, 0, 0, 0.20);
}

::-webkit-scrollbar {
  background-color: transparent;
  height: 12px;
}

/* background of the scrollbar except button or resizer */
::-webkit-scrollbar-track {
  background-color: transparent;
}

/* scrollbar itself */
::-webkit-scrollbar-thumb {
  background-color: #767680;
  border-radius: 16px;
  border: 4px solid #fff;
}

/* set button(top and bottom of the scrollbar) */
::-webkit-scrollbar-button {
  display:none;
}
</style>